#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2001-2005 Free Software Foundation
#
# FILE:
# forms/EventEditor.py
#
# DESCRIPTION:
# EventEditor wrapper for forms
#
# NOTES:
#


import sys, os, string
from wxPython.wx import *
from gnue.common.apps import GDebug
from gnue.common.formatting import GTypecast
from gnue.designer.base.tools.EventEditor import EventEditor as BaseEventEditor
from gnue.designer.base.tools.EventEditor import InspectorPanel as BaseInspectorPanel
from gnue.designer.base.ToolBase import *

class EventEditor (BaseEventEditor):
  def reset(self):
    BaseEventEditor.reset(self)

    #
    # GFEntry?  Show the corresponding GFField
    #
    if self.object._type == 'GFEntry':
      GDebug.printMesg(4,'Adding a new entry property manager')
      self.addPage(FieldInspectorPanel(self, self.notebook), "Field")
      if self.object._block:
        self.addPage(EntryBlockInspectorPanel(self, self.notebook), "Block")

    # Block?
    if self.object.findParentOfType('GFBlock',includeSelf=0):
      self.addPage(BlockInspectorPanel(self, self.notebook), "Block")



#
# Field properties (when Entry is selected)
#
class FieldInspectorPanel(BaseInspectorPanel):

  def setCurrent(self, object):
    self._setCurrent(object._field)

#
# Block properties (when Entry/Field is selected)
#
class BlockInspectorPanel(BaseInspectorPanel):

  def setCurrent(self, object):
    self._setCurrent(object.findParentOfType('GFBlock'))

class EntryBlockInspectorPanel(BaseInspectorPanel):
  def setCurrent(self, object):
    self._setCurrent(object._block)

