#
# Copyright 2002-2005 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# FILE:
# form/__init__.py
#
# DESCRIPTION:
# Various constants for the forms interface
#
# NOTES:
# This __init__ causes gnue.designer.forms to expose
# the Instance class plus a properties object.
#

# See if forms is installed
import gnue.forms as _test

class FormModuleProperties: #(_BaseInstance.ModuleProperties):

  module = 'forms'
  application = 'GNUe Forms'
  nickname = 'Form'
  description = 'GNUe Form Definition'
  xmlOpeningTag = 'form'

  fileExtensions = { 'gfd': 'GNUe Form Definition',
                     'gfl': 'GNUe Form Library' }

  defaultFileExtension = 'gfd'

properties = FormModuleProperties()

